//+------------------------------------------------------------------+
//|                                                    Percenter.mq4 |
//|                                   Copyright  2007, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

//----   -------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//----   ---------------------------------------------
extern int    Period_Ind      = 20;  //  MA
extern int    Method_Ind      = 0;   //   : 0-Simple, 1-Exponential, 2-Smoothed, 3-Weighted
extern int    Signal_Period   = 20;  //   
extern int    Signal_Method   = 0;   //   : 0-Simple, 1-Exponential, 2-Smoothed, 3-Weighted
extern int    Signal_Price    = 0;   // ,    : 0-Close, 1-Open, 2-Typical, 3-Weighted
extern bool   UseSmooth       = true;// true -  () 
extern int    MA_Period       = 7;   //   
extern int    MA_Method       = 0;   //   : 0-Simple, 1-Exponential, 2-Smoothed, 3-Weighted

//----  -------------------------------------------------------
static double SkillBuffer[];
static double SmoothBuffer[];

//----   -----------------------------------------
static int    sig_price;
static int    draw_begin;

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int init()
  {
//---- 1  
   IndicatorBuffers(2);
//----  ""  
   if(Method_Ind == 3) string ind_ma = "LWMA(";
   else if(Method_Ind == 2) ind_ma = "SMMA(";
        else if(Method_Ind == 1) ind_ma = "EMA(";
             else ind_ma = "SMA(";
   if(Signal_Method == 3) string sig_ma = "LWMA(";
   else if(Signal_Method == 2) sig_ma = "SMMA(";
        else if(Signal_Method == 1) sig_ma = "EMA(";
             else sig_ma = "SMA(";
   if(UseSmooth == false) string smt_ma = "";
   else
     {
      if(MA_Method == 3) smt_ma = "LWMA(";
      else if(MA_Method == 2) smt_ma = "SMMA(";
           else if(MA_Method == 1) smt_ma = "EMA(";
                else smt_ma = "SMA(";
      smt_ma = " with Smooth " + smt_ma + MA_Period + ")";
     }
   IndicatorShortName("Percenter "+ind_ma+Period_Ind+"),"+sig_ma+Signal_Period+")"+smt_ma);
//----    
   IndicatorDigits(2);
//----   
   SetLevelValue(0,00);
   SetLevelValue(1,30);
   SetLevelValue(2,-30);
//----    
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
//----     
   if(UseSmooth == false)
     {
      SetIndexBuffer(0,SkillBuffer);
      SetIndexBuffer(1,SmoothBuffer);
     }
   else
     {
      SetIndexBuffer(0,SmoothBuffer);
      SetIndexBuffer(1,SkillBuffer);
     }
//----      
   draw_begin = MathMax(Period_Ind,Signal_Period) + MA_Period;
   SetIndexDrawBegin(0,draw_begin);
//----    
   SetIndexLabel(0,"Percenter");
//----   
  if(Signal_Price == 3) sig_price = PRICE_WEIGHTED;
   else if(Signal_Price == 2) sig_price = PRICE_TYPICAL;
        else if(Signal_Price == 1) sig_price = PRICE_OPEN;
             else sig_price = PRICE_CLOSE;
//----  
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
int start()
  {
   //     ,    
   if(Bars <= MathMax(Period_Ind,Signal_Period)) return(0);
   //       
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   //     
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   if(limit > Bars - draw_begin) limit = Bars - draw_begin;
   for(int i=0; i<limit; i++)
     {
      double UpRound    = iMA(NULL,0,Period_Ind,0,Method_Ind,PRICE_HIGH,i);
      double DownRound  = iMA(NULL,0,Period_Ind,0,Method_Ind,PRICE_LOW,i);
      double SignalLine = iMA(NULL,0,Signal_Period,0,Signal_Method,sig_price,i);
      if(UpRound == DownRound) UpRound++;
      SkillBuffer[i] = ((SignalLine - DownRound)*100) / (UpRound - DownRound) - 50;
     }
   if(UseSmooth != false) for(i=0; i<limit; i++) SmoothBuffer[i] = iMAOnArray(SkillBuffer,0,MA_Period,0,MA_Method,i);
   else for(i=0; i<limit; i++) SmoothBuffer[i] = EMPTY_VALUE;
//----
   return(0);
  }
//+------------------------------------------------------------------+